#pragma once
#include <Wincrypt.h>
#include <atlenc.h>
#pragma comment(lib,"Advapi32.lib")
#pragma comment(lib,"rpcrt4.lib")

//-----------------------------------------------------------------------------------------
//   ÍCu[
//
//-----------------------------------------------------------------------------------------
class CXCrypto  
{
protected:
	HCRYPTPROV					m_hProv;				// cryptographic service provider (CSP). 
	HCRYPTHASH					m_hPwdHash;				// Hash Object
	HCRYPTKEY					m_hKey;					// generated key
    LPCTSTR                     pCSPName;

public:
	CXCrypto()
	{
		m_hProv = m_hPwdHash = m_hKey = NULL;
		pCSPName = NULL;
	}
	virtual ~CXCrypto()
	{
		Destroy();
	}

	//
	//   CSP쐬
	//
	BOOL CreateContainer ( )
	{
		BOOL bResult;
		DWORD ErrorNo;
		GUID  uuid;

		Destroy();

		UuidCreate ( &uuid );
		UuidToString ( &uuid , (PTBYTE *)&pCSPName );

		bResult = CryptAcquireContext(&m_hProv, pCSPName , MS_ENHANCED_PROV , PROV_RSA_FULL, CRYPT_NEWKEYSET | CRYPT_MACHINE_KEYSET); // ftHgRei擾
		ErrorNo = GetLastError();
		if(!bResult && ErrorNo == NTE_EXISTS) {  			/* L[ */
			bResult = CryptAcquireContext(&m_hProv, pCSPName , MS_ENHANCED_PROV, PROV_RSA_FULL, CRYPT_MACHINE_KEYSET);
			ErrorNo = GetLastError();
		}
		return bResult;
	}
	//
	//   pX[hݒ
	//
	void SetPassword ( LPCSTR pstrPassword ) 
	{
		if (m_hKey) {
			CryptDestroyKey(m_hKey);
			m_hKey = NULL;
		}
		if (m_hPwdHash) {
			CryptDestroyHash(m_hPwdHash);
			m_hPwdHash = NULL;
		}

		CryptCreateHash(m_hProv, CALG_MD5, 0, 0, &m_hPwdHash);
		CryptHashData(m_hPwdHash, (PBYTE)pstrPassword , lstrlen (pstrPassword) , 0);      // pX[hnbVIuWFNg
		CryptDeriveKey(m_hProv, CALG_RC4, m_hPwdHash, 0, &m_hKey);    //쐬
	}
	//
	//  Í(Base64GR[hf[^ɕϊ)
	//
	DWORD CryptToBase64 ( CString &strData , CString &strEndodeBase64Data )
	{
		CString strEncodeData ( strData );
		DWORD	dwDataSize = strEncodeData.GetLength();
		LPTSTR  pstrData = strEncodeData.GetBuffer(dwDataSize + 1);
		DWORD   dwRC;

		dwRC = CryptData ( (LPBYTE)pstrData , dwDataSize );
		
		if (dwRC == 0 ) {
			int  intEncodedSize = Base64EncodeGetRequiredLength ( dwDataSize );
			LPTSTR pstrEncoded = strEndodeBase64Data.GetBufferSetLength ( intEncodedSize );
			Base64Encode ( (LPBYTE)pstrData , dwDataSize , pstrEncoded , &intEncodedSize ); 
			strEndodeBase64Data.ReleaseBufferSetLength (intEncodedSize); 
		}
		strEncodeData.ReleaseBuffer ( );
		return dwRC;
	}
	//
	//  Í
	//
	DWORD CryptData ( LPBYTE pbytData , DWORD dwDataSize )
	{
		ATLASSERT ( m_hKey );
		DWORD	dwLastError;
		DWORD   dwSize;
		BOOL    blnLoop = FALSE;

		dwSize = dwDataSize;
		if (!CryptEncrypt(m_hKey, 0, TRUE, 0, pbytData , &dwSize, dwDataSize)){
			dwLastError = GetLastError();
			return dwLastError;
		}
		return 0;
	}
	//
	//     (Base64f[^𕡍)
	//
	DWORD DecryptFromBase64 ( CString &strBase64DecodeData , CString &strData )
	{
		LPTSTR pstrDecode = strBase64DecodeData.GetBuffer();
		int    intDecodeSize = strBase64DecodeData.GetLength();
		LPTSTR  pstrData = strData.GetBuffer(intDecodeSize + 1);
		DWORD	dwRC;

		Base64Decode ( pstrDecode , intDecodeSize , (PBYTE)pstrData , &intDecodeSize );
		strBase64DecodeData.ReleaseBuffer ();

		dwRC = DecryptData    ( (LPBYTE)pstrData , intDecodeSize );
		strData.ReleaseBufferSetLength ( intDecodeSize );
		return dwRC;
	}
	//
	//     
	//
	DWORD DecryptData ( LPBYTE pbytData , DWORD dwDataSize )
	{
		ATLASSERT ( m_hKey );
		DWORD	dwLastError;

		if (!CryptDecrypt(m_hKey, 0, TRUE, 0, pbytData , &dwDataSize )) {
			dwLastError = GetLastError();
			return dwLastError;
		}
		return 0;
	}
	//
	//     ÍIuWFNg̔j
	//
	void  Destroy()
	{
		if (m_hKey) {
			CryptDestroyKey(m_hKey);
			m_hKey = NULL;
		}
		if (m_hPwdHash) {
			CryptDestroyHash(m_hPwdHash);
			m_hPwdHash = NULL;
		}
		if (m_hProv) {
			CryptReleaseContext(m_hProv, 0);
			CryptAcquireContext(&m_hProv, pCSPName , MS_ENHANCED_PROV , PROV_RSA_FULL , CRYPT_DELETEKEYSET);
			m_hProv = NULL;
		}
		if ( pCSPName ) {
			RpcStringFree ( (PTBYTE *)&pCSPName );
			pCSPName = NULL;
		}

	}
};
