// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////
#pragma once


//******************************************************************************
// C
//
//******************************************************************************
class CMainFrame : public CFrameWindowImpl<CMainFrame>,
		public CMessageFilter, public CIdleHandler,
		private CXTaskTrayImpl <CMainFrame> ,
		public CMainFrameInterface
{
private:
	CPopupMon		m_clsPopupMon;								//|bvAbv
	CAboutDlg		*m_pdlgAboutBox;							// o[W
	CSettingSheet	*m_dlgSetting;

	GAITAMEMON_PARAM    m_udtParameter;							// Np^

public:
	DECLARE_FRAME_WND_CLASS(GAITAME_MAIN_WINDOW_CLASS_NAME, NULL)

	virtual BOOL PreTranslateMessage(MSG* pMsg)
	{
		return CFrameWindowImpl<CMainFrame>::PreTranslateMessage(pMsg);
	}

	virtual BOOL OnIdle()
	{
		return FALSE;
	}
	BEGIN_MSG_MAP_EX(CMainFrame)
		MSG_WM_CREATE(OnCreate)
		MSG_WM_DESTROY(OnDestroy)
		MSG_WM_ENDSESSION(OnEndSession)
		COMMAND_ID_HANDLER ( ID_POPUPMENU_EXIT     , OnPopupExit    )
		COMMAND_ID_HANDLER ( ID_POPUPMENU_ABOUTBOX , OnAboutBox     )
		COMMAND_ID_HANDLER ( ID_POPUPMENU_SETTING  , OnSettingDlg   )
		COMMAND_ID_HANDLER ( ID_POPUPMENU_INITPOS  , OnInitPosition )
		COMMAND_ID_HANDLER ( ID_POPUPMENU_STOPSOUND , OnStopSound   )			//TEh~
		CHAIN_MSG_MAP(CXTaskTrayImpl<CMainFrame>)        // ^XNgC
		CHAIN_MSG_MAP(CFrameWindowImpl<CMainFrame>)
	END_MSG_MAP()

// Handler prototypes (uncomment arguments if needed):
//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)
    LRESULT Open ()
	{
		_tsetlocale ( LC_ALL, _T("jpn") );
		m_udtParameter.Initalize ();
		try {
			MSXML2::IXMLDOMDocumentPtr pobjDOMDoc;
			MSXML2::IXMLDOMParseErrorPtr pobjDOMErr;

			TESTHR(pobjDOMDoc.CreateInstance ("Msxml2.DOMDocument"));
			_variant_t varXMLFile ( _T("GaitameMon.xml") );
			_variant_t varRC((BOOL)TRUE);
			pobjDOMDoc->Putasync(VARIANT_TRUE);
			pobjDOMDoc->PutpreserveWhiteSpace(VARIANT_TRUE);
			pobjDOMDoc->PutresolveExternals(VARIANT_FALSE);

			pobjDOMDoc->load(varXMLFile);									//p^t@CǍ
			pobjDOMErr = pobjDOMDoc->GetparseError();
			long lngRC = pobjDOMErr->GeterrorCode();

			switch (lngRC) {
			case  0:
				if (m_udtParameter.LoadParameter ( pobjDOMDoc ) != 0 ) {
					::MessageBox ( NULL ,  _T("p^t@CɃG[܂") , _T("O׃") , MB_OK | MB_ICONEXCLAMATION );
				}
				break;
			case 0x800c0005:											//t@CȂ
				break;
			default:
				{
					CString strMessage;
					_variant_t varReason = pobjDOMErr->Getreason();
					strMessage.Format ( _T("p^ǍsB\nR[h=%04X,ʒu=%d\nꏊ=%s") , 
											lngRC , pobjDOMErr->Getline() , (CString)varReason );
					::MessageBox ( NULL , strMessage , _T("O׃") , MB_OK  | MB_ICONEXCLAMATION );
					return 1;
				}
			}
		}
		catch ( ... )
		{
			::MessageBox ( NULL, _T("p^t@CǍ߂܂ł") , _T("O׃") , MB_OK | MB_ICONEXCLAMATION );
		}

		CreateEx ( );
		ShowWindow(SW_HIDE);
		::SetForegroundWindow(m_hWnd);	// Win95 needs this

		return 0;
	}
private:

	LRESULT OnCreate(LPCREATESTRUCT lpCreateStruct)
	{
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		ATLASSERT(pLoop != NULL);
		pLoop->AddMessageFilter(this);
		pLoop->AddIdleHandler(this);

		SetWindowPos ( NULL , -1 , -1 , 100 , 100 , SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOZORDER );

		CreateTray();
		AddTray();
		SetTrayIcon ( AtlLoadIcon(IDR_MAINFRAME) , _T("O׃"));

		m_clsPopupMon.MonitorCreate( this );
		m_pdlgAboutBox = NULL;
		m_dlgSetting   = NULL;
		return 0;
	}
	//
	// _uNbN
	//
	LRESULT OnTrayIcon_MouseLButtonDblClick ( POINT &posMouse )
	{
		if (m_pdlgAboutBox != NULL ) {					//?[_X_CAOJĂ
			return 0;
		}
		m_clsPopupMon.MonitorClose ( );
		return TRUE;
	}
	//
	// ^XNgCōNbN
	//
	//
	LRESULT OnTrayIcon_MouseLButtonUp( POINT &posMouse )
	{
		if (m_pdlgAboutBox != NULL ) {					//?[_X_CAOJĂ
			return 0;
		}
		SetForegroundWindow( m_clsPopupMon.m_hWnd );
		m_clsPopupMon.MonitorOpen ( );
		return TRUE;
	}
	//
	// ENbN
	//
	LRESULT OnTrayIcon_MouseRButtonUp( POINT &posMouse )
	{
		if (m_pdlgAboutBox || m_dlgSetting ) {					//?[_X_CAOJĂ
			return 0;
		}
//		if (m_clsPopupMon.m_HttpAccessInProgress) {			// HttpNGXg
//			return 0;
//		}
		CMenu clsMenu;
		clsMenu.CreatePopupMenu ();
		clsMenu.AppendMenu (  MF_STRING , ID_POPUPMENU_INITPOS   , _T("EBhEʒu"));
		clsMenu.AppendMenu (  MF_STRING , ID_POPUPMENU_STOPSOUND , _T("x~"));
		clsMenu.AppendMenu (  MF_SEPARATOR );
		clsMenu.AppendMenu (  MF_STRING , ID_POPUPMENU_ABOUTBOX , _T("o[W"));
		clsMenu.AppendMenu (  MF_STRING , ID_POPUPMENU_SETTING  , _T("ݒ"));
		clsMenu.AppendMenu (  MF_SEPARATOR );
		clsMenu.AppendMenu (  MF_STRING , ID_POPUPMENU_EXIT , _T("I"));
		
		SetForegroundWindow( m_hWnd );
		m_clsPopupMon.PauseHttpAccess( TRUE );                         //^C}[Xgbv
		clsMenu.TrackPopupMenu ( TPM_RIGHTBUTTON | TPM_RIGHTALIGN  | TPM_BOTTOMALIGN ,
			                     posMouse.x ,
								 posMouse.y ,
								 m_hWnd );
		m_clsPopupMon.PauseHttpAccess( FALSE );                        
		return TRUE;
	}
	//
	// ^XNo[̍č쐬
	//
	void OnTrayIcon_TaskbarRestart ()
	{
		AddTray ();																	//gCǉ
		SetTrayIcon ( AtlLoadIcon(IDR_MAINFRAME) , _T("O׃"));
	}
	//
	// ʒȕj[
	//
	LRESULT OnInitPosition (WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		m_clsPopupMon.MonitorClose();
		m_udtParameter.m_clsRectRateWindow.SetRectEmpty();
		return 0;
	}
	//
	// Ij[
	//
	LRESULT OnPopupExit(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		m_clsPopupMon.MonitorDestroy();
		DestroyWindow();
		return 0;
	}
	//
	// o[W\
	//
	LRESULT OnAboutBox(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		m_clsPopupMon.PauseHttpAccess( TRUE );                         //^C}[Xgbv
		m_pdlgAboutBox = new CAboutDlg;
		m_pdlgAboutBox->DoModal(*this );
		delete m_pdlgAboutBox;
		m_pdlgAboutBox = NULL;
		m_clsPopupMon.PauseHttpAccess( FALSE );                      //^C}[ĊJ
		return 0;
	}
	//
	// ݒ
	//
	LRESULT OnSettingDlg(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		m_clsPopupMon.PauseHttpAccess( TRUE );                         //^C}[Xgbv

		m_dlgSetting = new CSettingSheet (_T("ݒ"));
		
		m_dlgSetting->SetParemeterPtr ( &m_udtParameter , &m_clsPopupMon );
        if(m_dlgSetting->DoModal() == IDOK){
			m_clsPopupMon.MonitorDestroy();
			m_clsPopupMon.MonitorCreate( this );
        }
		delete m_dlgSetting;
		m_dlgSetting = NULL;
		m_clsPopupMon.PauseHttpAccess( FALSE );                      //^C}[ĊJ
		return 0;
	}
	//
	// x~
	//
	LRESULT OnStopSound (WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		PlaySound ( NULL , NULL , 0);
		return 0;
	}
	//
	//p^f[^̃Z[u
	//
	void SaveParameterData()
	{
		try {
			MSXML2::IXMLDOMDocumentPtr pobjDOMDoc;
			TESTHR(pobjDOMDoc.CreateInstance ("Msxml2.DOMDocument"));
			_variant_t varXMLFile ( _T("GaitameMon.xml") );
			_variant_t varRC((BOOL)TRUE);
			pobjDOMDoc->Putasync(VARIANT_TRUE);
			pobjDOMDoc->PutpreserveWhiteSpace(VARIANT_TRUE);
			pobjDOMDoc->PutresolveExternals(VARIANT_FALSE);

			m_udtParameter.SaveParameter ( pobjDOMDoc );

			if (pobjDOMDoc->save(varXMLFile) != S_OK ) {						//p^t@C
				throw(1);
			}
		}
		catch ( ... )
		{
			::MessageBox ( NULL, _T("p^t@C߂܂ł") , _T("O׃") , MB_OK | MB_ICONEXCLAMATION |MB_SYSTEMMODAL);
		}

	}
	//
	//
	//
	void OnDestroy()
	{
		if (m_clsPopupMon.IsWindow()) {
			m_clsPopupMon.MonitorDestroy();
		}

		SaveParameterData ();
//		SetTrayIcon ( NULL , _T("O׃:I҂"));
//		DWORD lngRC = ::WaitForSingleObject ( g_hThreadHttpRequest , INFINITE  );

		DeleteTray();															//gC폜

		SetMsgHandled ( FALSE );
	}
	//
	// WindowI
	//
	void OnEndSession(BOOL bEnding, UINT nOption)
	{
		if (bEnding) {
			if (m_clsPopupMon.IsWindow()) {
				m_clsPopupMon.MonitorDestroy();
			}

			SaveParameterData ();

			DeleteTray();															//gC폜

		}
	}
	//
	//  c[`bv\
	//
	void OnDisplayInfoTips ( LPCTSTR  strString , DWORD dwIconFalg)
	{
		if (m_udtParameter.m_blnDisplayError) {			//?DisplayErrorw肠
			SetInfoTips ( strString , _T("ERROR") , dwIconFalg );
		}
	}
	//
	//  c[`bv\(qbg)
	//
	void OnDisplayInfoTipsOnHit ( LPCTSTR strTitle , LPCTSTR strString )
	{
		SetInfoTips ( strString , strTitle , NIIF_WARNING , 30000 );
	}
	//
	// c[`bv
	//
	void OnDisplayTips ( LPCTSTR strDisplay )
	{
		SetTrayIcon ( NULL , strDisplay );		//c[`bvŕ\
	}
	//
	// ACRZbg
	//
	void SetTrayIcon2 ( HICON hIcon )
	{
		SetTrayIcon ( hIcon );
	}
	//
	// EBhEnh擾
	//
	HWND GethWnd ()
	{
		return m_hWnd;
	}
	//
	// p^擾
	//
	GAITAMEMON_PARAM *GetParameter() {
		return &m_udtParameter;
	}
};
