//
#pragma once
#include "SettingSheet0.h"

//-----------------------------------------------------------------
//  vݒy[W
//-----------------------------------------------------------------
class CSetting_Clock_Page : public CPropertyPageImpl<CSetting_Clock_Page>
{
private:
	CCheckListViewCtrl   m_listview_Clock;
	CButton         m_button_Add;
	CButton			m_button_Delete;
	CButton			m_button_Edit;
	CButton			m_button_Up;
	CButton			m_button_Down;
	CTrackBarCtrl   m_trackbar_Time;
public:
    enum { IDD = IDD_SETTING_CLOCK };

	PCGAITAMEMON_PARAM    g_pParameter;							// Np^ւ̃|C^
    // RXgN^
    CSetting_Clock_Page(ATL::_U_STRINGorID title = (LPCTSTR)NULL)
        : CPropertyPageImpl<CSetting_Clock_Page>(title)
    {}

    BEGIN_MSG_MAP_EX(CSetting_Clock_Page)
        MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_HANDLER_EX ( IDC_BUTTON_CLOCK_ADD    , BN_CLICKED , OnButtonAdd    )
		COMMAND_HANDLER_EX ( IDC_BUTTON_CLOCK_DELETE , BN_CLICKED , OnButtonDelete )
		COMMAND_HANDLER_EX ( IDC_BUTTON_CLOCK_EDIT   , BN_CLICKED , OnButtonEdit   )
		COMMAND_HANDLER_EX ( IDC_BUTTON_CLOCK_CLEAR  , BN_CLICKED , OnButtonClear  )
		COMMAND_HANDLER_EX ( IDC_BUTTON_CLOCK_UP     , BN_CLICKED , OnButtonUp     )
		COMMAND_HANDLER_EX ( IDC_BUTTON_CLOCK_DOWN   , BN_CLICKED , OnButtonDown   )
		NOTIFY_HANDLER_EX  ( IDC_LIST_CLOCK , NM_CLICK ,OnListSelected )  //LVN_ITEMCHANGED
		NOTIFY_HANDLER_EX  ( IDC_SLIDER_CLOCK_TZ     , NM_CUSTOMDRAW , OnChangeSlider )
		CHAIN_MSG_MAP(CPropertyPageImpl<CSetting_Clock_Page>)
    END_MSG_MAP()

	// 
	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam)
	{
		m_listview_Clock.SubclassWindow ( GetDlgItem ( IDC_LIST_CLOCK     ));
		m_button_Add               = GetDlgItem ( IDC_BUTTON_CLOCK_ADD );
		m_button_Delete            = GetDlgItem ( IDC_BUTTON_CLOCK_DELETE );
		m_button_Edit              = GetDlgItem ( IDC_BUTTON_CLOCK_EDIT );
		m_button_Up                = GetDlgItem ( IDC_BUTTON_CLOCK_UP );
		m_button_Down              = GetDlgItem ( IDC_BUTTON_CLOCK_DOWN );
		m_trackbar_Time            = GetDlgItem ( IDC_SLIDER_CLOCK_TZ );

		m_listview_Clock.SetExtendedListViewStyle ( LVS_EX_CHECKBOXES | LVS_EX_FULLROWSELECT );
		CHeaderCtrl hdr = m_listview_Clock.GetHeader();
		hdr.ModifyStyle(HDS_BUTTONS, 0);

        m_trackbar_Time.SetRange(-24, 24);
        m_trackbar_Time.SetTicFreq(6);
        m_trackbar_Time.SetPageSize(3);
        m_trackbar_Time.SetLineSize(1);
        m_trackbar_Time.SetPos(0);

		// add a listview column
		m_listview_Clock.AddColumn(_T("O                  "), hdr.GetItemCount());
		m_listview_Clock.AddColumn(_T("GMT̎"), hdr.GetItemCount());

		for ( size_t i = 0 ; i < g_pParameter->m_tblClock.GetCount() ; i++ ) {
			ClockParameterTable tblClock;
			tblClock = g_pParameter->m_tblClock[i];
			int nIndex = m_listview_Clock.GetItemCount();
			m_listview_Clock.AddItem ( nIndex  , 0 , tblClock.strName );
			CString strTime;
			strTime.Format( "%d" , tblClock.clsSpanTime.GetHours () );
			m_listview_Clock.AddItem ( nIndex  , 1 , strTime );
			m_listview_Clock.SetCheckState ( nIndex , tblClock.blnEnabled ); 
		}

		::SendMessage ( GetDlgItem (IDC_EDIT_CLOCK_NAME)   , EM_LIMITTEXT, 20, 0L);

		RefreshControl();
		return TRUE;
	}
	LRESULT OnChangeSlider ( LPNMHDR lpHdr )
	{
		SetDlgItemInt  ( IDC_STATIC_CLOCK_TZ         , m_trackbar_Time.GetPos()  );
		return FALSE;
	}
	LRESULT OnListSelected ( LPNMHDR lpHdr )
	{
		CString strText;
		int nIndex = m_listview_Clock.GetSelectedIndex ();
		if ( nIndex >= 0 ) {
			m_listview_Clock.GetItemText ( nIndex , 0 , strText );
			SetDlgItemText ( IDC_EDIT_CLOCK_NAME      , strText );
			m_listview_Clock.GetItemText ( nIndex , 1 , strText );
			int intHour = _ttoi (strText);
			m_trackbar_Time.SetPos(intHour);
		}
		RefreshControl();
		return FALSE;
	}
	// ǉ{^
	void OnButtonAdd ( UINT nCode , int nID , HWND hWnd )
	{
		char strBuf[21];
		int nIndex = m_listview_Clock.GetSelectedIndex ();
		nIndex++;

		GetDlgItemText ( IDC_EDIT_CLOCK_NAME, strBuf , 20 );
		m_listview_Clock.InsertItem ( nIndex ,  strBuf );
		int intHour = m_trackbar_Time.GetPos();
		CString strTime;
		strTime.Format ( _T("%d") , intHour );
		m_listview_Clock.SetItemText   ( nIndex  , 1 , strTime );
		m_listview_Clock.SetCheckState ( nIndex  , 1);
		m_listview_Clock.SelectItem    ( nIndex );
		RefreshControl();

	}
	// 폜{^
	void OnButtonDelete ( UINT nCode , int nID , HWND hWnd )
	{
		int nIndex = m_listview_Clock.GetSelectedIndex ();
		m_listview_Clock.DeleteItem  ( nIndex );
		int intCount =  m_listview_Clock.GetItemCount ();

		if ( intCount > 0 ) {
			if ( nIndex >= intCount ) {
				--nIndex;
			}
			m_listview_Clock.SelectItem    ( nIndex );
		}
		RefreshControl();
	}
	// ύX{^
	void OnButtonEdit ( UINT nCode , int nID , HWND hWnd )
	{
		char strBuf[21];
		int nIndex = m_listview_Clock.GetSelectedIndex ();
		GetDlgItemText ( IDC_EDIT_CLOCK_NAME, strBuf , 20 );
		m_listview_Clock.SetItemText ( nIndex , 0 ,  strBuf );

		int intHour = m_trackbar_Time.GetPos();
		CString strTime;
		strTime.Format ( _T("%d") , intHour );
		m_listview_Clock.SetItemText   ( nIndex  , 1 , (LPCTSTR)strTime );
		RefreshControl();
	}
	// NA{^
	void OnButtonClear ( UINT nCode , int nID , HWND hWnd )
	{
		SetDlgItemText ( IDC_EDIT_CLOCK_NAME       , "" );
		m_trackbar_Time.SetPos( 0 );
		RefreshControl();
	}
	// {^
	void OnButtonUp ( UINT nCode , int nID , HWND hWnd )
	{
		CString strName;
		CString strTZ;
		BOOL    blnCheck;

		int nIndex = m_listview_Clock.GetSelectedIndex ();
		if ( nIndex > 0 ) {
			m_listview_Clock.GetItemText ( nIndex , 0 , strName );
			m_listview_Clock.GetItemText ( nIndex , 1 , strTZ );
			blnCheck = m_listview_Clock.GetCheckState ( nIndex );

			m_listview_Clock.DeleteItem (nIndex);
			nIndex--;
			m_listview_Clock.InsertItem	   ( nIndex  ,  strName );
			m_listview_Clock.SetItemText   ( nIndex  , 1 , strTZ );
			m_listview_Clock.SetCheckState ( nIndex  , blnCheck);
			m_listview_Clock.SelectItem    ( nIndex );
		}
		RefreshControl();
	}
	// {^
	void OnButtonDown ( UINT nCode , int nID , HWND hWnd )
	{
		CString strName;
		CString strTZ;
		BOOL    blnCheck;

		int nIndex = m_listview_Clock.GetSelectedIndex ();
		if ( nIndex < m_listview_Clock.GetItemCount() - 1 ) {
			m_listview_Clock.GetItemText ( nIndex , 0 , strName );
			m_listview_Clock.GetItemText ( nIndex , 1 , strTZ );
			blnCheck = m_listview_Clock.GetCheckState ( nIndex );

			m_listview_Clock.DeleteItem (nIndex);
			nIndex++;
			m_listview_Clock.InsertItem	   ( nIndex  ,  strName );
			m_listview_Clock.SetItemText   ( nIndex  , 1 , strTZ );
			m_listview_Clock.SetCheckState ( nIndex  , blnCheck);
			m_listview_Clock.SelectItem    ( nIndex );
		}
		RefreshControl();
	}
	void RefreshControl()
	{
		int nIndex = m_listview_Clock.GetSelectedIndex ();
		int	nCount = m_listview_Clock.GetItemCount();
		m_button_Add.EnableWindow( TRUE );
		if ( nIndex >= 0 ) {
			m_button_Delete.EnableWindow ( TRUE );
			m_button_Edit.EnableWindow   ( TRUE );
			if ( nIndex > 0 ) {
				m_button_Up.EnableWindow ( TRUE );
			}
			else {
				m_button_Up.EnableWindow ( FALSE );
			}
			if ( nIndex < nCount - 1) {
				m_button_Down.EnableWindow ( TRUE );
			}
			else {
				m_button_Down.EnableWindow ( FALSE );
			}
		}
		else {
			m_button_Delete.EnableWindow ( FALSE );
			m_button_Edit.EnableWindow   ( FALSE );
			m_button_Up.EnableWindow     ( FALSE );
			m_button_Down.EnableWindow   ( FALSE );
		}
	}
	// OK{^
    BOOL OnApply(){
		CString strTZ;
		int nCount = m_listview_Clock.GetItemCount();
		g_pParameter->m_tblClock.RemoveAll();

		for ( int i = 0 ; i < nCount ; i++ ) {
			ClockParameterTable tblClock;
			m_listview_Clock.GetItemText ( i , 0 , tblClock.strName );
			m_listview_Clock.GetItemText ( i , 1 , strTZ );
			tblClock.blnEnabled = m_listview_Clock.GetCheckState ( i );
			int intHour = _ttoi (strTZ);
			tblClock.clsSpanTime.SetDateTimeSpan ( 0 , intHour , 0 , 0 );
			g_pParameter->m_tblClock.Add ( tblClock );
		}
		return TRUE;
	}
};
//-----------------------------------------------------------------
//  C^[lbgݒy[W
//-----------------------------------------------------------------
class CSetting_Internet_Page : public CPropertyPageImpl<CSetting_Internet_Page>
{
private:
	CButton m_option_Proxy_None;
	CButton m_option_Proxy_System;
	CButton m_option_Proxy_Manual;

public:
    enum { IDD = IDD_SETTING_INTERNET };

	PCGAITAMEMON_PARAM    g_pParameter;							// Np^ւ̃|C^
	CPopupMon		  	 *g_pclsPopupMon;	                    //|bvAbv

    // RXgN^
    CSetting_Internet_Page(ATL::_U_STRINGorID title = (LPCTSTR)NULL)
        : CPropertyPageImpl<CSetting_Internet_Page>(title)
    {}

    BEGIN_MSG_MAP_EX(CSetting_Internet_Page)
        MSG_WM_INITDIALOG(OnInitDialog)
        CHAIN_MSG_MAP(CPropertyPageImpl<CSetting_Internet_Page>)
    END_MSG_MAP()

	// 
	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam)
	{

		m_option_Proxy_None           = GetDlgItem ( IDC_RADIO_PROXY_NONE     );
		m_option_Proxy_System         = GetDlgItem ( IDC_RADIO_PROXY_SYSTEM   );
		m_option_Proxy_Manual         = GetDlgItem ( IDC_RADIO_PROXY_MANUAL   );

		::SendMessage ( GetDlgItem (IDC_EDIT_PROXY_ADDRESS)   , EM_LIMITTEXT, 32, 0L);
		::SendMessage ( GetDlgItem (IDC_EDIT_PROXY_PORT)      , EM_LIMITTEXT,  5, 0L);
		::SendMessage ( GetDlgItem (IDC_EDIT_PROXY_USER)      , EM_LIMITTEXT, 99, 0L);
		::SendMessage ( GetDlgItem (IDC_EDIT_PROXY_PASSWORD)  , EM_LIMITTEXT, 99, 0L);

		// vLVݒ
		switch (g_pParameter->m_enmUseProxy_User) {
		case GAITAMEMON_PROXY_USE_NONE:
			m_option_Proxy_None.SetCheck ( 1 );
			break;
		case GAITAMEMON_PROXY_USE_IE:
			m_option_Proxy_System.SetCheck ( 1 );
			break;
		case GAITAMEMON_PROXY_USE_SET:
			m_option_Proxy_Manual.SetCheck ( 1 );
			break;
		}
		SetDlgItemText ( IDC_EDIT_PROXY_ADDRESS       , g_pParameter->m_strProxyServer );
		SetDlgItemInt  ( IDC_EDIT_PROXY_PORT          , g_pParameter->m_intProxyPort , FALSE );
		SetDlgItemText ( IDC_EDIT_PROXY_USER          , g_pParameter->m_strProxyUserID );
		SetDlgItemText ( IDC_EDIT_PROXY_PASSWORD      , g_pParameter->m_strProxyPassword );
		SetDlgItemInt  ( IDC_EDIT_INTERVAL_TIME_OPEN  ,g_pParameter->m_intIntervalTimeOnDisplay , FALSE );
		SetDlgItemInt  ( IDC_EDIT_INTERVAL_TIME_CLOSE , g_pParameter->m_intIntervalTimeOnHidden , FALSE );

		return TRUE;
    }
	// OK{^
    BOOL OnApply(){
		DWORD dwErr;
		DWORD dwProxyEnabled;
		CRegKey rkProxy;

		if (ParameterCheck() == FALSE ) {						//?p^`FbN
			return FALSE;										// G[
		}

		// vLVݒ
		if ( m_option_Proxy_None.GetCheck() == 1 ) {
			g_pParameter->m_enmUseProxy_User = GAITAMEMON_PROXY_USE_NONE;
		}
		else if ( m_option_Proxy_System.GetCheck() == 1 ) {
			g_pParameter->m_enmUseProxy_User = GAITAMEMON_PROXY_USE_IE;
		}
		else {
			g_pParameter->m_enmUseProxy_User = GAITAMEMON_PROXY_USE_SET;
		}
		switch (g_pParameter->m_enmUseProxy_User) {
		case GAITAMEMON_PROXY_USE_NONE:
		case GAITAMEMON_PROXY_USE_SET:
			g_pParameter->m_enmUseProxy = g_pParameter->m_enmUseProxy_User;
			break;
		default:
			dwErr = rkProxy.Open(HKEY_CURRENT_USER, _T("Software\\Microsoft\\Windows\\CurrentVersion\\Internet Settings"), KEY_READ);
			if (dwErr == ERROR_SUCCESS) {
				dwErr = rkProxy.QueryDWORDValue( _T("ProxyEnable"), dwProxyEnabled);
			}
			if ( dwProxyEnabled != 0 ) {                    //?Proxyw
				g_pParameter->m_enmUseProxy = GAITAMEMON_PROXY_USE_IE   ; // Proxy IE
			}
			else {
				g_pParameter->m_enmUseProxy = GAITAMEMON_PROXY_USE_NONE; // ProxyȂ
			}
			break;
		}

		GetDlgItemText ( IDC_EDIT_PROXY_ADDRESS , g_pParameter->m_strProxyServer.GetBufferSetLength( 128 ) , 128);
		g_pParameter->m_strProxyServer.ReleaseBuffer();
		g_pParameter->m_intProxyPort = GetDlgItemInt ( IDC_EDIT_PROXY_PORT , NULL ,FALSE );
		GetDlgItemText ( IDC_EDIT_PROXY_USER, g_pParameter->m_strProxyUserID.GetBufferSetLength(128),128);
		g_pParameter->m_strProxyUserID.ReleaseBuffer();
		GetDlgItemText ( IDC_EDIT_PROXY_PASSWORD, g_pParameter->m_strProxyPassword.GetBufferSetLength(128),128);
		g_pParameter->m_strProxyPassword.ReleaseBuffer();
		g_pParameter->m_intIntervalTimeOnDisplay = GetDlgItemInt ( IDC_EDIT_INTERVAL_TIME_OPEN , NULL ,FALSE );
		g_pParameter->m_intIntervalTimeOnHidden  = GetDlgItemInt ( IDC_EDIT_INTERVAL_TIME_CLOSE , NULL ,FALSE );

		g_pParameter->RefreshItems();

		return TRUE;
    }
	// Cancel{^
	void OnReset()
	{
	}
	bool ParameterCheck()
	{
		if (GetDlgItemInt ( IDC_EDIT_INTERVAL_TIME_OPEN , NULL ,FALSE )  < 1  ) {
			MessageBox ( _T ( "JANZXԊu̎w肪ł" ) , MB_OK );
			return FALSE;
		}
		if (GetDlgItemInt ( IDC_EDIT_INTERVAL_TIME_CLOSE , NULL ,FALSE )  < 1  ) {
			MessageBox ( _T ( "鎞ANZXԊu̎w肪ł" ) , MB_OK );
			return FALSE;
		}
		return TRUE;
	}
};
//-----------------------------------------------------------------
//  ݒy[W
//-----------------------------------------------------------------
class CSetting_Window_Page : public CPropertyPageImpl<CSetting_Window_Page>
{
private:
	CButton m_option_AlwaysTop;
	CButton m_option_DisplayError;

	CColorSettingButton m_button_Color_Date_Fore;
	CColorSettingButton m_button_Color_Date_Back;
	CColorSettingButton m_button_Color_Title_Fore;
	CColorSettingButton m_button_Color_Title_Back;
	CColorSettingButton m_button_Color_Body_Fore;
	CColorSettingButton m_button_Color_Body_Back;
	CColorSettingButton m_button_Color_RateUp_Fore;
	CColorSettingButton m_button_Color_RateUp_Back;
	CColorSettingButton m_button_Color_RateDown_Fore;
	CColorSettingButton m_button_Color_RateDown_Back;
	CButton m_check_RateCangeIndicate;

	CButton m_check_Display_Window[RATEITEM_COUNTS];
	CButton m_option_Display_ToolTip[RATEITEM_COUNTS];

	CTrackBarCtrl   m_trackbar_Alpha;							//xw
	CButton         m_option_OpenDirection_UP;
	CButton         m_option_OpenDirection_Down;
	CButton			m_check_UseColorKey;						//{̔wiFœ߂ɂ
public:
    enum { IDD = IDD_SETTING_WINDOW };

	PCGAITAMEMON_PARAM    g_pParameter;							// Np^ւ̃|C^
	CPopupMon		  	 *g_pclsPopupMon;	                    //|bvAbv

    // RXgN^
    CSetting_Window_Page(ATL::_U_STRINGorID title = (LPCTSTR)NULL)
        : CPropertyPageImpl<CSetting_Window_Page>(title)
    {}

    BEGIN_MSG_MAP_EX(CSetting_Window_Page)
        MSG_WM_INITDIALOG(OnInitDialog)
		NOTIFY_HANDLER_EX  ( IDC_SLIDER_SETTING_ALPHA      , NM_CUSTOMDRAW , OnChangeSlider_Alpha )
        CHAIN_MSG_MAP(CPropertyPageImpl<CSetting_Window_Page>)
    END_MSG_MAP()

	// 
	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam)
	{
		m_option_AlwaysTop            = GetDlgItem ( IDC_CHECK_ALWAYS_TOP     );
		m_option_DisplayError         = GetDlgItem ( IDC_CHECK_ERROR_DISPLAY  );
		m_trackbar_Alpha              = GetDlgItem ( IDC_SLIDER_SETTING_ALPHA );

		m_button_Color_Date_Fore.Attach     ( GetDlgItem ( IDC_BUTTONCOLOR_DATE_FORE)    , g_pParameter->m_ColorDateText );
		m_button_Color_Date_Back.Attach     ( GetDlgItem ( IDC_BUTTONCOLOR_DATE_BACK)    , g_pParameter->m_ColorDateBack);
		m_button_Color_Title_Fore.Attach    ( GetDlgItem ( IDC_BUTTONCOLOR_TITLE_FORE)   , g_pParameter->m_ColorHeaderText);
		m_button_Color_Title_Back.Attach    ( GetDlgItem ( IDC_BUTTONCOLOR_TITLE_BACK)   , g_pParameter->m_ColorHeaderBack);
		m_button_Color_Body_Fore.Attach     ( GetDlgItem ( IDC_BUTTONCOLOR_BODY_FORE)    , g_pParameter->m_ColorBodyText);
		m_button_Color_Body_Back.Attach     ( GetDlgItem ( IDC_BUTTONCOLOR_BODY_BACK)    , g_pParameter->m_ColorBodyBack);
		m_button_Color_RateUp_Fore.Attach   ( GetDlgItem ( IDC_BUTTONCOLOR_RATEUP_FORE)  , g_pParameter->m_ColorRateUpText);
		m_button_Color_RateUp_Back.Attach   ( GetDlgItem ( IDC_BUTTONCOLOR_RATEUP_BACK)  , g_pParameter->m_ColorRateUpBack);
		m_button_Color_RateDown_Fore.Attach ( GetDlgItem ( IDC_BUTTONCOLOR_RATEDOWN_FORE), g_pParameter->m_ColorRateDownText);
		m_button_Color_RateDown_Back.Attach ( GetDlgItem ( IDC_BUTTONCOLOR_RATEDOWN_BACK), g_pParameter->m_ColorRateDownBack);

		m_check_RateCangeIndicate     = GetDlgItem ( IDC_CHECK_RATE_CHANGE_INDICATE );

		m_check_Display_Window[RATEITEM_USDJPY]   = GetDlgItem ( IDC_CHECK_DISPLAY_WINDOW_USDJPY );
		m_option_Display_ToolTip[RATEITEM_USDJPY] = GetDlgItem ( IDC_RADIO_DISPLAY_WINDOW_USDJPY );
		m_check_Display_Window[RATEITEM_EURJPY]   = GetDlgItem ( IDC_CHECK_DISPLAY_WINDOW_EURJPY );
		m_option_Display_ToolTip[RATEITEM_EURJPY] = GetDlgItem ( IDC_RADIO_DISPLAY_WINDOW_EURJPY );
		m_check_Display_Window[RATEITEM_EURUSD]   = GetDlgItem ( IDC_CHECK_DISPLAY_WINDOW_EURUSD );
		m_option_Display_ToolTip[RATEITEM_EURUSD] = GetDlgItem ( IDC_RADIO_DISPLAY_WINDOW_EURUSD );
		m_check_Display_Window[RATEITEM_AUDJPY]   = GetDlgItem ( IDC_CHECK_DISPLAY_WINDOW_AUDJPY );
		m_option_Display_ToolTip[RATEITEM_AUDJPY] = GetDlgItem ( IDC_RADIO_DISPLAY_WINDOW_AUDJPY );
		m_check_Display_Window[RATEITEM_GBPJPY]   = GetDlgItem ( IDC_CHECK_DISPLAY_WINDOW_GBPJPY );
		m_option_Display_ToolTip[RATEITEM_GBPJPY] = GetDlgItem ( IDC_RADIO_DISPLAY_WINDOW_GBPJPY );
		m_check_Display_Window[RATEITEM_NZDJPY]   = GetDlgItem ( IDC_CHECK_DISPLAY_WINDOW_NZDJPY );
		m_option_Display_ToolTip[RATEITEM_NZDJPY] = GetDlgItem ( IDC_RADIO_DISPLAY_WINDOW_NZDJPY );
		m_check_Display_Window[RATEITEM_CANJPY]   = GetDlgItem ( IDC_CHECK_DISPLAY_WINDOW_CADJPY );
		m_option_Display_ToolTip[RATEITEM_CANJPY] = GetDlgItem ( IDC_RADIO_DISPLAY_WINDOW_CADJPY );
		m_check_Display_Window[RATEITEM_CHFJPY]   = GetDlgItem ( IDC_CHECK_DISPLAY_WINDOW_CHFJPY );
		m_option_Display_ToolTip[RATEITEM_CHFJPY] = GetDlgItem ( IDC_RADIO_DISPLAY_WINDOW_CHFJPY );
		m_check_Display_Window[RATEITEM_HKDJPY]   = GetDlgItem ( IDC_CHECK_DISPLAY_WINDOW_HKDJPY );
		m_option_Display_ToolTip[RATEITEM_HKDJPY] = GetDlgItem ( IDC_RADIO_DISPLAY_WINDOW_HKDJPY );
		m_check_Display_Window[RATEITEM_GBPUSD]   = GetDlgItem ( IDC_CHECK_DISPLAY_WINDOW_GBPUSD );
		m_option_Display_ToolTip[RATEITEM_GBPUSD] = GetDlgItem ( IDC_RADIO_DISPLAY_WINDOW_GBPUSD );
		m_check_Display_Window[RATEITEM_USDCHF]   = GetDlgItem ( IDC_CHECK_DISPLAY_WINDOW_USDCHF );
		m_option_Display_ToolTip[RATEITEM_USDCHF] = GetDlgItem ( IDC_RADIO_DISPLAY_WINDOW_USDCHF );
		m_check_Display_Window[RATEITEM_ZARJPY]   = GetDlgItem ( IDC_CHECK_DISPLAY_WINDOW_ZARJPY );
		m_option_Display_ToolTip[RATEITEM_ZARJPY] = GetDlgItem ( IDC_RADIO_DISPLAY_WINDOW_ZARJPY );

		m_option_OpenDirection_UP                 = GetDlgItem ( IDC_RADIO_SETTING_WINDOW_OPEN_UP   );
		m_option_OpenDirection_Down               = GetDlgItem ( IDC_RADIO_SETTING_WINDOW_OPEN_DOWN );
		m_check_UseColorKey						  = GetDlgItem ( IDC_CHECK_USE_COLOR_KEY );

		m_option_AlwaysTop.SetCheck       ( (g_pParameter->m_blnRateWindowAlwaysTop ? 1:0)); 
		m_option_DisplayError.SetCheck    ( (g_pParameter->m_blnDisplayError ? 1:0)); 

		m_check_RateCangeIndicate.SetCheck ((g_pParameter->m_blnRateChangeIndicate ? 1:0));

		for (int i = 0 ; i < RATEITEM_COUNTS ; i++ ) {
			m_check_Display_Window[i].SetCheck ((g_pParameter->m_blnRateDisplay[i] ? 1:0));
			if (i == g_pParameter->m_enmRateDisplayTipsIndex) {
				m_option_Display_ToolTip[i].SetCheck(1);
			}
			else {
				m_option_Display_ToolTip[i].SetCheck(0);
			}
		}
        m_trackbar_Alpha.SetRange(0, 100);
        m_trackbar_Alpha.SetTicFreq(5);
        m_trackbar_Alpha.SetPageSize(5);
        m_trackbar_Alpha.SetLineSize(1);
        m_trackbar_Alpha.SetPos(g_pParameter->m_intAlpha);

		m_option_OpenDirection_UP.SetCheck   ((g_pParameter->m_enmPopupGrow == POPUP_GROW_DIR_BOTTOM_TO_TOP) ? 1:0 );
		m_option_OpenDirection_Down.SetCheck ((g_pParameter->m_enmPopupGrow == POPUP_GROW_DIR_TOP_TO_BOTTOM) ? 1:0 );
		m_check_UseColorKey.SetCheck (g_pParameter->m_blnUseColorKey  ? 1:0 );
		return TRUE;
    }
	// OK{^
    BOOL OnApply()
	{
		g_pParameter->m_blnRateWindowAlwaysTop  = (m_option_AlwaysTop.GetCheck() == 1 );
		g_pParameter->m_blnRateChangeIndicate   = (m_check_RateCangeIndicate.GetCheck() == 1 );
		g_pParameter->m_blnDisplayError         = (m_option_DisplayError.GetCheck()     == 1 );

		for (int i = 0 ; i < RATEITEM_COUNTS ; i++ ) {
			g_pParameter->m_blnRateDisplay[i] = (m_check_Display_Window[i].GetCheck() == 1);
			if (m_option_Display_ToolTip[i].GetCheck() == 1 ) {
				g_pParameter->m_enmRateDisplayTipsIndex = (RATEITEM)i;
			}
		}
		g_pParameter->m_ColorDateText    = m_button_Color_Date_Fore.GetColor();
		g_pParameter->m_ColorDateBack    = m_button_Color_Date_Back.GetColor();
		g_pParameter->m_ColorHeaderText  = m_button_Color_Title_Fore.GetColor();
		g_pParameter->m_ColorHeaderBack  = m_button_Color_Title_Back.GetColor();
		g_pParameter->m_ColorBodyText    = m_button_Color_Body_Fore.GetColor();
		g_pParameter->m_ColorBodyBack    = m_button_Color_Body_Back.GetColor();
		g_pParameter->m_ColorRateUpText  = m_button_Color_RateUp_Fore.GetColor();
		g_pParameter->m_ColorRateUpBack  = m_button_Color_RateUp_Back.GetColor();
		g_pParameter->m_ColorRateDownText= m_button_Color_RateDown_Fore.GetColor();
		g_pParameter->m_ColorRateDownBack= m_button_Color_RateDown_Back.GetColor();

		g_pParameter->RefreshItems();

		g_pParameter->m_intAlpha = m_trackbar_Alpha.GetPos();

		if ( m_option_OpenDirection_UP.GetCheck() == 1) {
			g_pParameter->m_enmPopupGrow = POPUP_GROW_DIR_BOTTOM_TO_TOP;
		}
		else {
			g_pParameter->m_enmPopupGrow = POPUP_GROW_DIR_TOP_TO_BOTTOM;
		}
		g_pParameter->m_blnUseColorKey    = (m_check_UseColorKey.GetCheck()     == 1 );
		return TRUE;
    }
	// Cancel{^
	void OnReset()
	{
		g_pclsPopupMon->OnChangeAlpha ( g_pParameter->m_intAlpha , 
										g_pParameter->m_blnUseColorKey);    //Ƃ̓xʂɔf
	}
	//
	// xXC_[ړ
	//
	LRESULT OnChangeSlider_Alpha ( LPNMHDR lpHdr )
	{
		CString strValue;
		int     intAlpha;
		BOOL	blnUseColorKey;

		intAlpha = m_trackbar_Alpha.GetPos();
		strValue.Format ( _T("%d%%") , intAlpha);
		SetDlgItemText  ( IDC_STATIC_SETTING_POPUP_ALPHA   , (LPCTSTR)strValue  );
		blnUseColorKey =(m_check_UseColorKey.GetCheck()     == 1 );
		g_pclsPopupMon->OnChangeAlpha ( intAlpha , blnUseColorKey );          //xʂɔf
		return FALSE;
	}
};
//-----------------------------------------------------------------
//  ~b^[ݒy[W(1)
//-----------------------------------------------------------------
class CSetting_Limiter_1_Page : public CPropertyPageImpl<CSetting_Limiter_1_Page>
{
private:
	CXEditNumeric	m_editLimit[RATEITEM_COUNTS][LIMIT_INDEX_COUNT][LIMIT_BIDASK_COUNT];
	CButton         m_check_Enabled[RATEITEM_COUNTS][LIMIT_INDEX_COUNT];
	CStatic			m_label_Status[RATEITEM_COUNTS][LIMIT_INDEX_COUNT];
	CButton         m_option_Action[LIMIT_HIT_ACTION_COUNT];
	CButton         m_check_Hit_Sound;
	CButton         m_check_Hit_Sound_Loop;						//AĐ

public:
    enum { IDD = IDD_SETTING_LIMIT_1 };

	PCGAITAMEMON_PARAM    g_pParameter;							// Np^ւ̃|C^

    // RXgN^
    CSetting_Limiter_1_Page(ATL::_U_STRINGorID title = (LPCTSTR)NULL)
        : CPropertyPageImpl<CSetting_Limiter_1_Page>(title)
    {}

    BEGIN_MSG_MAP_EX(CSetting_Limiter_1_Page)
		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_USDJPY_1 , BN_CLICKED , OnClickClearStatus )
 		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_USDJPY_2 , BN_CLICKED , OnClickClearStatus )
		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_EURJPY_1 , BN_CLICKED , OnClickClearStatus )
 		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_EURJPY_2 , BN_CLICKED , OnClickClearStatus )
		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_EURUSD_1 , BN_CLICKED , OnClickClearStatus )
 		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_EURUSD_2 , BN_CLICKED , OnClickClearStatus )
		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_AUDJPY_1 , BN_CLICKED , OnClickClearStatus )
		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_AUDJPY_2 , BN_CLICKED , OnClickClearStatus )
		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_GBPJPY_1 , BN_CLICKED , OnClickClearStatus )
 		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_GBPJPY_2 , BN_CLICKED , OnClickClearStatus )
		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_NZDJPY_1 , BN_CLICKED , OnClickClearStatus )
 		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_NZDJPY_2 , BN_CLICKED , OnClickClearStatus )

		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_REFER_SHELL    , BN_CLICKED , OnClickReferShell  )
 		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_REFER_SOUND    , BN_CLICKED , OnClickReferSound  )
		MSG_WM_INITDIALOG(OnInitDialog)
        CHAIN_MSG_MAP(CPropertyPageImpl<CSetting_Limiter_1_Page>)

    END_MSG_MAP()

	// 
	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam)
	{
		m_editLimit[RATEITEM_USDJPY][LIMIT_INDEX_0][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_USDJPY_BID_1) , g_pParameter->m_curLimit[RATEITEM_USDJPY][LIMIT_INDEX_0][LIMIT_BIDASK_BID] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_USDJPY][LIMIT_INDEX_0][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_USDJPY_ASK_1) , g_pParameter->m_curLimit[RATEITEM_USDJPY][LIMIT_INDEX_0][LIMIT_BIDASK_ASK] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_USDJPY][LIMIT_INDEX_1][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_USDJPY_BID_2) , g_pParameter->m_curLimit[RATEITEM_USDJPY][LIMIT_INDEX_1][LIMIT_BIDASK_BID] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_USDJPY][LIMIT_INDEX_1][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_USDJPY_ASK_2) , g_pParameter->m_curLimit[RATEITEM_USDJPY][LIMIT_INDEX_1][LIMIT_BIDASK_ASK] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );

		m_editLimit[RATEITEM_EURJPY][LIMIT_INDEX_0][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_EURJPY_BID_1) , g_pParameter->m_curLimit[RATEITEM_EURJPY][LIMIT_INDEX_0][LIMIT_BIDASK_BID] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_EURJPY][LIMIT_INDEX_0][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_EURJPY_ASK_1) , g_pParameter->m_curLimit[RATEITEM_EURJPY][LIMIT_INDEX_0][LIMIT_BIDASK_ASK] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_EURJPY][LIMIT_INDEX_1][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_EURJPY_BID_2) , g_pParameter->m_curLimit[RATEITEM_EURJPY][LIMIT_INDEX_1][LIMIT_BIDASK_BID] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_EURJPY][LIMIT_INDEX_1][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_EURJPY_ASK_2) , g_pParameter->m_curLimit[RATEITEM_EURJPY][LIMIT_INDEX_1][LIMIT_BIDASK_ASK] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );

		m_editLimit[RATEITEM_EURUSD][LIMIT_INDEX_0][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_EURUSD_BID_1) , g_pParameter->m_curLimit[RATEITEM_EURUSD][LIMIT_INDEX_0][LIMIT_BIDASK_BID] , 1  , 4 , CComCurrency ( 9 , 9999 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_EURUSD][LIMIT_INDEX_0][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_EURUSD_ASK_1) , g_pParameter->m_curLimit[RATEITEM_EURUSD][LIMIT_INDEX_0][LIMIT_BIDASK_ASK] , 1  , 4 , CComCurrency ( 9 , 9999 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_EURUSD][LIMIT_INDEX_1][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_EURUSD_BID_2) , g_pParameter->m_curLimit[RATEITEM_EURUSD][LIMIT_INDEX_1][LIMIT_BIDASK_BID] , 1  , 4 , CComCurrency ( 9 , 9999 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_EURUSD][LIMIT_INDEX_1][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_EURUSD_ASK_2) , g_pParameter->m_curLimit[RATEITEM_EURUSD][LIMIT_INDEX_1][LIMIT_BIDASK_ASK] , 1  , 4 , CComCurrency ( 9 , 9999 ) , CComCurrency ( 0 , 0 ) );

		m_editLimit[RATEITEM_AUDJPY][LIMIT_INDEX_0][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_AUDJPY_BID_1) , g_pParameter->m_curLimit[RATEITEM_AUDJPY][LIMIT_INDEX_0][LIMIT_BIDASK_BID] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_AUDJPY][LIMIT_INDEX_0][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_AUDJPY_ASK_1) , g_pParameter->m_curLimit[RATEITEM_AUDJPY][LIMIT_INDEX_0][LIMIT_BIDASK_ASK] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_AUDJPY][LIMIT_INDEX_1][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_AUDJPY_BID_2) , g_pParameter->m_curLimit[RATEITEM_AUDJPY][LIMIT_INDEX_1][LIMIT_BIDASK_BID] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_AUDJPY][LIMIT_INDEX_1][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_AUDJPY_ASK_2) , g_pParameter->m_curLimit[RATEITEM_AUDJPY][LIMIT_INDEX_1][LIMIT_BIDASK_ASK] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );

		m_editLimit[RATEITEM_GBPJPY][LIMIT_INDEX_0][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_GBPJPY_BID_1) , g_pParameter->m_curLimit[RATEITEM_GBPJPY][LIMIT_INDEX_0][LIMIT_BIDASK_BID] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_GBPJPY][LIMIT_INDEX_0][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_GBPJPY_ASK_1) , g_pParameter->m_curLimit[RATEITEM_GBPJPY][LIMIT_INDEX_0][LIMIT_BIDASK_ASK] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_GBPJPY][LIMIT_INDEX_1][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_GBPJPY_BID_2) , g_pParameter->m_curLimit[RATEITEM_GBPJPY][LIMIT_INDEX_1][LIMIT_BIDASK_BID] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_GBPJPY][LIMIT_INDEX_1][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_GBPJPY_ASK_2) , g_pParameter->m_curLimit[RATEITEM_GBPJPY][LIMIT_INDEX_1][LIMIT_BIDASK_ASK] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );

		m_editLimit[RATEITEM_NZDJPY][LIMIT_INDEX_0][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_NZDJPY_BID_1) , g_pParameter->m_curLimit[RATEITEM_NZDJPY][LIMIT_INDEX_0][LIMIT_BIDASK_BID] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_NZDJPY][LIMIT_INDEX_0][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_NZDJPY_ASK_1) , g_pParameter->m_curLimit[RATEITEM_NZDJPY][LIMIT_INDEX_0][LIMIT_BIDASK_ASK] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_NZDJPY][LIMIT_INDEX_1][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_NZDJPY_BID_2) , g_pParameter->m_curLimit[RATEITEM_NZDJPY][LIMIT_INDEX_1][LIMIT_BIDASK_BID] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_NZDJPY][LIMIT_INDEX_1][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_NZDJPY_ASK_2) , g_pParameter->m_curLimit[RATEITEM_NZDJPY][LIMIT_INDEX_1][LIMIT_BIDASK_ASK] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );

		m_check_Enabled[RATEITEM_USDJPY][LIMIT_INDEX_0] = GetDlgItem(IDC_LIMIT_CHECK_USDJPY_ENABLE_1);
		m_check_Enabled[RATEITEM_USDJPY][LIMIT_INDEX_1] = GetDlgItem(IDC_LIMIT_CHECK_USDJPY_ENABLE_2);
		m_check_Enabled[RATEITEM_EURJPY][LIMIT_INDEX_0] = GetDlgItem(IDC_LIMIT_CHECK_EURJPY_ENABLE_1);
		m_check_Enabled[RATEITEM_EURJPY][LIMIT_INDEX_1] = GetDlgItem(IDC_LIMIT_CHECK_EURJPY_ENABLE_2);
		m_check_Enabled[RATEITEM_EURUSD][LIMIT_INDEX_0] = GetDlgItem(IDC_LIMIT_CHECK_EURUSD_ENABLE_1);
		m_check_Enabled[RATEITEM_EURUSD][LIMIT_INDEX_1] = GetDlgItem(IDC_LIMIT_CHECK_EURUSD_ENABLE_2);
		m_check_Enabled[RATEITEM_AUDJPY][LIMIT_INDEX_0] = GetDlgItem(IDC_LIMIT_CHECK_AUDJPY_ENABLE_1);
		m_check_Enabled[RATEITEM_AUDJPY][LIMIT_INDEX_1] = GetDlgItem(IDC_LIMIT_CHECK_AUDJPY_ENABLE_2);
		m_check_Enabled[RATEITEM_GBPJPY][LIMIT_INDEX_0] = GetDlgItem(IDC_LIMIT_CHECK_GBPJPY_ENABLE_1);
		m_check_Enabled[RATEITEM_GBPJPY][LIMIT_INDEX_1] = GetDlgItem(IDC_LIMIT_CHECK_GBPJPY_ENABLE_2);
		m_check_Enabled[RATEITEM_NZDJPY][LIMIT_INDEX_0] = GetDlgItem(IDC_LIMIT_CHECK_NZDJPY_ENABLE_1);
		m_check_Enabled[RATEITEM_NZDJPY][LIMIT_INDEX_1] = GetDlgItem(IDC_LIMIT_CHECK_NZDJPY_ENABLE_2);

		m_label_Status[RATEITEM_USDJPY][LIMIT_INDEX_0]  = GetDlgItem(IDC_LIMIT_STATIC_USDJPY_STATUS_1);
		m_label_Status[RATEITEM_USDJPY][LIMIT_INDEX_1]  = GetDlgItem(IDC_LIMIT_STATIC_USDJPY_STATUS_2);
		m_label_Status[RATEITEM_EURJPY][LIMIT_INDEX_0]  = GetDlgItem(IDC_LIMIT_STATIC_EURJPY_STATUS_1);
		m_label_Status[RATEITEM_EURJPY][LIMIT_INDEX_1]  = GetDlgItem(IDC_LIMIT_STATIC_EURJPY_STATUS_2);
		m_label_Status[RATEITEM_EURUSD][LIMIT_INDEX_0]  = GetDlgItem(IDC_LIMIT_STATIC_EURUSD_STATUS_1);
		m_label_Status[RATEITEM_EURUSD][LIMIT_INDEX_1]  = GetDlgItem(IDC_LIMIT_STATIC_EURUSD_STATUS_2);
		m_label_Status[RATEITEM_AUDJPY][LIMIT_INDEX_0]  = GetDlgItem(IDC_LIMIT_STATIC_AUDJPY_STATUS_1);
		m_label_Status[RATEITEM_AUDJPY][LIMIT_INDEX_1]  = GetDlgItem(IDC_LIMIT_STATIC_AUDJPY_STATUS_2);
		m_label_Status[RATEITEM_GBPJPY][LIMIT_INDEX_0]  = GetDlgItem(IDC_LIMIT_STATIC_GBPJPY_STATUS_1);
		m_label_Status[RATEITEM_GBPJPY][LIMIT_INDEX_1]  = GetDlgItem(IDC_LIMIT_STATIC_GBPJPY_STATUS_2);
		m_label_Status[RATEITEM_NZDJPY][LIMIT_INDEX_0]  = GetDlgItem(IDC_LIMIT_STATIC_NZDJPY_STATUS_1);
		m_label_Status[RATEITEM_NZDJPY][LIMIT_INDEX_1]  = GetDlgItem(IDC_LIMIT_STATIC_NZDJPY_STATUS_2);

		for ( int intUNITIndex = RATEITEM_USDJPY ; intUNITIndex < RATEITEM_NZDJPY+1 ; intUNITIndex++ ) {
			for ( int intIndex = 0 ; intIndex < LIMIT_INDEX_COUNT ; intIndex++ ) {
				m_check_Enabled[intUNITIndex][intIndex].SetCheck     ( g_pParameter->m_blnLimitEnabled[intUNITIndex][intIndex] );
				m_label_Status[intUNITIndex][intIndex].SetWindowText ( g_pParameter->m_strLimitStatus[intUNITIndex][intIndex] );
			}
		}
		m_option_Action[LIMIT_HIT_ACTION_NONE]  = GetDlgItem(IDC_LIMIT_RADIO_HITEXEC_NONE);
		m_option_Action[LIMIT_HIT_ACTION_SHELL] = GetDlgItem(IDC_LIMIT_RADIO_HITEXEC_SHELL);
		m_option_Action[LIMIT_HIT_ACTION_TIPS]  = GetDlgItem(IDC_LIMIT_RADIO_HITEXEC_INFOTIP);

		switch (g_pParameter->m_enmLimitHitAction) {
		case LIMIT_HIT_ACTION_NONE:
			m_option_Action[LIMIT_HIT_ACTION_NONE].SetCheck ( TRUE );
			break;
		case LIMIT_HIT_ACTION_SHELL:
			m_option_Action[LIMIT_HIT_ACTION_SHELL].SetCheck ( TRUE );
			break; 
		case LIMIT_HIT_ACTION_TIPS:
			m_option_Action[LIMIT_HIT_ACTION_TIPS].SetCheck ( TRUE );
			break;
		}
		SetDlgItemText ( IDC_LIMIT_EDIT_HITEXEC_SHELL       , g_pParameter->m_strLimitHitShell );
		SetDlgItemText ( IDC_LIMIT_EDIT_HITEXEC_SHELL_PARAM , g_pParameter->m_strLimitHitShellCommandLine );
		::SendMessage  ( GetDlgItem (IDC_LIMIT_EDIT_HITEXEC_SHELL)         , EM_LIMITTEXT, 128, 0L);
		::SendMessage  ( GetDlgItem (IDC_LIMIT_EDIT_HITEXEC_SHELL_PARAM)   , EM_LIMITTEXT, 128, 0L);

		m_check_Hit_Sound = GetDlgItem ( IDC_LIMIT_CHECK_HIT_AT_SOUND );
		m_check_Hit_Sound.SetCheck ( g_pParameter->m_blnLimitHitSound );
		SetDlgItemText ( IDC_LIMIT_EDIT_HIT_AT_SOUNFILE , g_pParameter->m_strLimitHitSoundFile );
		::SendMessage  ( GetDlgItem (IDC_LIMIT_EDIT_HIT_AT_SOUNFILE)   , EM_LIMITTEXT, 128, 0L);
		m_check_Hit_Sound_Loop = GetDlgItem ( IDC_LIMIT_CHECK_HIT_AT_SOUND_LOOP );
		m_check_Hit_Sound_Loop.SetCheck ( g_pParameter->m_blnLimitHitSoundLoop );

		return 0;
	}
	// OK{^
    BOOL OnApply(){
		for ( int intUNITIndex = RATEITEM_USDJPY ; intUNITIndex < RATEITEM_NZDJPY+1 ; intUNITIndex++ ) {
			for ( int intIndex = 0 ; intIndex < LIMIT_INDEX_COUNT ; intIndex++ ) {
				m_editLimit[intUNITIndex][intIndex][LIMIT_BIDASK_BID].GetValue ( g_pParameter->m_curLimit[intUNITIndex][intIndex][LIMIT_BIDASK_BID] );
				m_editLimit[intUNITIndex][intIndex][LIMIT_BIDASK_ASK].GetValue ( g_pParameter->m_curLimit[intUNITIndex][intIndex][LIMIT_BIDASK_ASK] );
				g_pParameter->m_blnLimitEnabled[intUNITIndex][intIndex] = (m_check_Enabled[intUNITIndex][intIndex].GetCheck() == 1);
			    m_label_Status[intUNITIndex][intIndex].GetWindowText(g_pParameter->m_strLimitStatus[intUNITIndex][intIndex]);
			}
		}
		if ( m_option_Action[LIMIT_HIT_ACTION_NONE].GetCheck() != 0 ) {
			g_pParameter->m_enmLimitHitAction = LIMIT_HIT_ACTION_NONE;
		}
		if ( m_option_Action[LIMIT_HIT_ACTION_SHELL].GetCheck() != 0 ) {
			g_pParameter->m_enmLimitHitAction = LIMIT_HIT_ACTION_SHELL;
		}
		if ( m_option_Action[LIMIT_HIT_ACTION_TIPS].GetCheck() != 0 ) {
			g_pParameter->m_enmLimitHitAction = LIMIT_HIT_ACTION_TIPS;
		}
		GetDlgItemText ( IDC_LIMIT_EDIT_HITEXEC_SHELL, g_pParameter->m_strLimitHitShell.GetBufferSetLength (128),128);
		g_pParameter->m_strLimitHitShell.ReleaseBuffer();
		GetDlgItemText ( IDC_LIMIT_EDIT_HITEXEC_SHELL_PARAM, g_pParameter->m_strLimitHitShellCommandLine.GetBufferSetLength (128),128);
		g_pParameter->m_strLimitHitShellCommandLine.ReleaseBuffer();

		g_pParameter->m_blnLimitHitSound = m_check_Hit_Sound.GetCheck ();
		GetDlgItemText ( IDC_LIMIT_EDIT_HIT_AT_SOUNFILE, g_pParameter->m_strLimitHitSoundFile.GetBufferSetLength (128),128);
		g_pParameter->m_strLimitHitSoundFile.ReleaseBuffer();
		g_pParameter->m_blnLimitHitSoundLoop = m_check_Hit_Sound_Loop.GetCheck ();
		return TRUE;
	}
	//  NA{^
	void OnClickClearStatus(UINT uNotifyCode, int nID, HWND hWndCtl)
	{
		switch ( nID ) {
		case IDC_LIMIT_BUTTON_CLEAR_USDJPY_1:
			m_label_Status[RATEITEM_USDJPY][LIMIT_INDEX_0].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_USDJPY_2:
			m_label_Status[RATEITEM_USDJPY][LIMIT_INDEX_1].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_EURJPY_1:
			m_label_Status[RATEITEM_EURJPY][LIMIT_INDEX_0].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_EURJPY_2:
			m_label_Status[RATEITEM_EURJPY][LIMIT_INDEX_1].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_EURUSD_1:
			m_label_Status[RATEITEM_EURUSD][LIMIT_INDEX_0].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_EURUSD_2:
			m_label_Status[RATEITEM_EURUSD][LIMIT_INDEX_1].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_AUDJPY_1:
			m_label_Status[RATEITEM_AUDJPY][LIMIT_INDEX_0].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_AUDJPY_2:
			m_label_Status[RATEITEM_AUDJPY][LIMIT_INDEX_1].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_GBPJPY_1:
			m_label_Status[RATEITEM_GBPJPY][LIMIT_INDEX_0].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_GBPJPY_2:
			m_label_Status[RATEITEM_GBPJPY][LIMIT_INDEX_1].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_NZDJPY_1:
			m_label_Status[RATEITEM_NZDJPY][LIMIT_INDEX_0].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_NZDJPY_2:
			m_label_Status[RATEITEM_NZDJPY][LIMIT_INDEX_1].SetWindowText("");
			break;
		}
	}
	//  VFQƃ{^
	void OnClickReferShell(UINT uNotifyCode, int nID, HWND hWndCtl)
	{
		CFileDialog dlg ( TRUE , _T("exe"), NULL , OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_EXPLORER, _T("s`(*.exe)\0*.exe\0"));
		dlg.m_ofn.lpstrInitialDir = "";
		dlg.m_ofn.lpstrTitle      = _T("s`w肷");
		if(dlg.DoModal() == IDOK){
			SetDlgItemText ( IDC_LIMIT_EDIT_HITEXEC_SHELL       , dlg.m_szFileName);
		}
	}
	//  Qƃ{^
	void OnClickReferSound(UINT uNotifyCode, int nID, HWND hWndCtl)
	{
		CFileDialog dlg ( TRUE , _T("wav"), NULL , OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_EXPLORER, _T("s`(*.wav)\0*.wav\0"));
		dlg.m_ofn.lpstrTitle      = _T("TEhw肷");
		if(dlg.DoModal() == IDOK){
			SetDlgItemText ( IDC_LIMIT_EDIT_HIT_AT_SOUNFILE       ,dlg.m_szFileName );
		}
	}
};
//-----------------------------------------------------------------
//  ~b^[ݒy[W(2)
//-----------------------------------------------------------------
class CSetting_Limiter_2_Page : public CPropertyPageImpl<CSetting_Limiter_2_Page>
{
private:
	CXEditNumeric	m_editLimit[RATEITEM_COUNTS][LIMIT_INDEX_COUNT][LIMIT_BIDASK_COUNT];
	CButton         m_check_Enabled[RATEITEM_COUNTS][LIMIT_INDEX_COUNT];
	CStatic			m_label_Status[RATEITEM_COUNTS][LIMIT_INDEX_COUNT];
public:
    enum { IDD = IDD_SETTING_LIMIT_2 };

	PCGAITAMEMON_PARAM    g_pParameter;							// Np^ւ̃|C^

    // RXgN^
    CSetting_Limiter_2_Page(ATL::_U_STRINGorID title = (LPCTSTR)NULL)
        : CPropertyPageImpl<CSetting_Limiter_2_Page>(title)
    {}

    BEGIN_MSG_MAP_EX(CSetting_Limiter_2_Page)
		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_CADJPY_1 , BN_CLICKED , OnClickClearStatus )
 		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_CADJPY_2 , BN_CLICKED , OnClickClearStatus )
		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_CHFJPY_1 , BN_CLICKED , OnClickClearStatus )
 		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_CHFJPY_2 , BN_CLICKED , OnClickClearStatus )
		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_HKDJPY_1 , BN_CLICKED , OnClickClearStatus )
 		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_HKDJPY_2 , BN_CLICKED , OnClickClearStatus )
		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_GBPUSD_1 , BN_CLICKED , OnClickClearStatus )
 		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_GBPUSD_2 , BN_CLICKED , OnClickClearStatus )
		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_USDCHF_1 , BN_CLICKED , OnClickClearStatus )
 		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_USDCHF_2 , BN_CLICKED , OnClickClearStatus )
		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_ZARJPY_1 , BN_CLICKED , OnClickClearStatus )
 		COMMAND_HANDLER_EX ( IDC_LIMIT_BUTTON_CLEAR_ZARJPY_2 , BN_CLICKED , OnClickClearStatus )
		MSG_WM_INITDIALOG(OnInitDialog)
        CHAIN_MSG_MAP(CPropertyPageImpl<CSetting_Limiter_2_Page>)

    END_MSG_MAP()

	// 
	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam)
	{
		m_editLimit[RATEITEM_CANJPY][LIMIT_INDEX_0][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_CADJPY_BID_1) , g_pParameter->m_curLimit[RATEITEM_CANJPY][LIMIT_INDEX_0][LIMIT_BIDASK_BID] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_CANJPY][LIMIT_INDEX_0][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_CADJPY_ASK_1) , g_pParameter->m_curLimit[RATEITEM_CANJPY][LIMIT_INDEX_0][LIMIT_BIDASK_ASK] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_CANJPY][LIMIT_INDEX_1][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_CADJPY_BID_2) , g_pParameter->m_curLimit[RATEITEM_CANJPY][LIMIT_INDEX_1][LIMIT_BIDASK_BID] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_CANJPY][LIMIT_INDEX_1][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_CADJPY_ASK_2) , g_pParameter->m_curLimit[RATEITEM_CANJPY][LIMIT_INDEX_1][LIMIT_BIDASK_ASK] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );

		m_editLimit[RATEITEM_CHFJPY][LIMIT_INDEX_0][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_CHFJPY_BID_1) , g_pParameter->m_curLimit[RATEITEM_CHFJPY][LIMIT_INDEX_0][LIMIT_BIDASK_BID] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_CHFJPY][LIMIT_INDEX_0][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_CHFJPY_ASK_1) , g_pParameter->m_curLimit[RATEITEM_CHFJPY][LIMIT_INDEX_0][LIMIT_BIDASK_ASK] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_CHFJPY][LIMIT_INDEX_1][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_CHFJPY_BID_2) , g_pParameter->m_curLimit[RATEITEM_CHFJPY][LIMIT_INDEX_1][LIMIT_BIDASK_BID] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_CHFJPY][LIMIT_INDEX_1][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_CHFJPY_ASK_2) , g_pParameter->m_curLimit[RATEITEM_CHFJPY][LIMIT_INDEX_1][LIMIT_BIDASK_ASK] , 3  , 2 , CComCurrency ( 999 , 99 ) , CComCurrency ( 0 , 0 ) );

		m_editLimit[RATEITEM_HKDJPY][LIMIT_INDEX_0][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_HKDJPY_BID_1) , g_pParameter->m_curLimit[RATEITEM_HKDJPY][LIMIT_INDEX_0][LIMIT_BIDASK_BID] , 2  , 2 , CComCurrency (  99 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_HKDJPY][LIMIT_INDEX_0][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_HKDJPY_ASK_1) , g_pParameter->m_curLimit[RATEITEM_HKDJPY][LIMIT_INDEX_0][LIMIT_BIDASK_ASK] , 2  , 2 , CComCurrency (  99 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_HKDJPY][LIMIT_INDEX_1][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_HKDJPY_BID_2) , g_pParameter->m_curLimit[RATEITEM_HKDJPY][LIMIT_INDEX_1][LIMIT_BIDASK_BID] , 2  , 2 , CComCurrency (  99 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_HKDJPY][LIMIT_INDEX_1][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_HKDJPY_ASK_2) , g_pParameter->m_curLimit[RATEITEM_HKDJPY][LIMIT_INDEX_1][LIMIT_BIDASK_ASK] , 2  , 2 , CComCurrency (  99 , 99 ) , CComCurrency ( 0 , 0 ) );
																																								  
		m_editLimit[RATEITEM_GBPUSD][LIMIT_INDEX_0][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_GBPUSD_BID_1) , g_pParameter->m_curLimit[RATEITEM_GBPUSD][LIMIT_INDEX_0][LIMIT_BIDASK_BID] , 1  , 4 , CComCurrency (   9 , 9999 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_GBPUSD][LIMIT_INDEX_0][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_GBPUSD_ASK_1) , g_pParameter->m_curLimit[RATEITEM_GBPUSD][LIMIT_INDEX_0][LIMIT_BIDASK_ASK] , 1  , 4 , CComCurrency (   9 , 9999 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_GBPUSD][LIMIT_INDEX_1][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_GBPUSD_BID_2) , g_pParameter->m_curLimit[RATEITEM_GBPUSD][LIMIT_INDEX_1][LIMIT_BIDASK_BID] , 1  , 4 , CComCurrency (   9 , 9999 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_GBPUSD][LIMIT_INDEX_1][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_GBPUSD_ASK_2) , g_pParameter->m_curLimit[RATEITEM_GBPUSD][LIMIT_INDEX_1][LIMIT_BIDASK_ASK] , 1  , 4 , CComCurrency (   9 , 9999 ) , CComCurrency ( 0 , 0 ) );

		m_editLimit[RATEITEM_USDCHF][LIMIT_INDEX_0][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_USDCHF_BID_1) , g_pParameter->m_curLimit[RATEITEM_USDCHF][LIMIT_INDEX_0][LIMIT_BIDASK_BID] , 1  , 4 , CComCurrency (   9 , 9999 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_USDCHF][LIMIT_INDEX_0][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_USDCHF_ASK_1) , g_pParameter->m_curLimit[RATEITEM_USDCHF][LIMIT_INDEX_0][LIMIT_BIDASK_ASK] , 1  , 4 , CComCurrency (   9 , 9999 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_USDCHF][LIMIT_INDEX_1][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_USDCHF_BID_2) , g_pParameter->m_curLimit[RATEITEM_USDCHF][LIMIT_INDEX_1][LIMIT_BIDASK_BID] , 1  , 4 , CComCurrency (   9 , 9999 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_USDCHF][LIMIT_INDEX_1][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_USDCHF_ASK_2) , g_pParameter->m_curLimit[RATEITEM_USDCHF][LIMIT_INDEX_1][LIMIT_BIDASK_ASK] , 1  , 4 , CComCurrency (   9 , 9999 ) , CComCurrency ( 0 , 0 ) );

		m_editLimit[RATEITEM_ZARJPY][LIMIT_INDEX_0][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_ZARJPY_BID_1) , g_pParameter->m_curLimit[RATEITEM_ZARJPY][LIMIT_INDEX_0][LIMIT_BIDASK_BID] , 2  , 2 , CComCurrency (  99 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_ZARJPY][LIMIT_INDEX_0][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_ZARJPY_ASK_1) , g_pParameter->m_curLimit[RATEITEM_ZARJPY][LIMIT_INDEX_0][LIMIT_BIDASK_ASK] , 2  , 2 , CComCurrency (  99 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_ZARJPY][LIMIT_INDEX_1][LIMIT_BIDASK_BID].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_ZARJPY_BID_2) , g_pParameter->m_curLimit[RATEITEM_ZARJPY][LIMIT_INDEX_1][LIMIT_BIDASK_BID] , 2  , 2 , CComCurrency (  99 , 99 ) , CComCurrency ( 0 , 0 ) );
		m_editLimit[RATEITEM_ZARJPY][LIMIT_INDEX_1][LIMIT_BIDASK_ASK].Attach (	GetDlgItem(IDC_LIMIT_EDIT_LIMIT_ZARJPY_ASK_2) , g_pParameter->m_curLimit[RATEITEM_ZARJPY][LIMIT_INDEX_1][LIMIT_BIDASK_ASK] , 2  , 2 , CComCurrency (  99 , 99 ) , CComCurrency ( 0 , 0 ) );

		m_check_Enabled[RATEITEM_CANJPY][LIMIT_INDEX_0] = GetDlgItem(IDC_LIMIT_CHECK_CADJPY_ENABLE_1);
		m_check_Enabled[RATEITEM_CANJPY][LIMIT_INDEX_1] = GetDlgItem(IDC_LIMIT_CHECK_CADJPY_ENABLE_2);
		m_check_Enabled[RATEITEM_CHFJPY][LIMIT_INDEX_0] = GetDlgItem(IDC_LIMIT_CHECK_CHFJPY_ENABLE_1);
		m_check_Enabled[RATEITEM_CHFJPY][LIMIT_INDEX_1] = GetDlgItem(IDC_LIMIT_CHECK_CHFJPY_ENABLE_2);
		m_check_Enabled[RATEITEM_HKDJPY][LIMIT_INDEX_0] = GetDlgItem(IDC_LIMIT_CHECK_HKDJPY_ENABLE_1);
		m_check_Enabled[RATEITEM_HKDJPY][LIMIT_INDEX_1] = GetDlgItem(IDC_LIMIT_CHECK_HKDJPY_ENABLE_2);
		m_check_Enabled[RATEITEM_GBPUSD][LIMIT_INDEX_0] = GetDlgItem(IDC_LIMIT_CHECK_GBPUSD_ENABLE_1);
		m_check_Enabled[RATEITEM_GBPUSD][LIMIT_INDEX_1] = GetDlgItem(IDC_LIMIT_CHECK_GBPUSD_ENABLE_2);
		m_check_Enabled[RATEITEM_USDCHF][LIMIT_INDEX_0] = GetDlgItem(IDC_LIMIT_CHECK_USDCHF_ENABLE_1);
		m_check_Enabled[RATEITEM_USDCHF][LIMIT_INDEX_1] = GetDlgItem(IDC_LIMIT_CHECK_USDCHF_ENABLE_2);
		m_check_Enabled[RATEITEM_ZARJPY][LIMIT_INDEX_0] = GetDlgItem(IDC_LIMIT_CHECK_ZARJPY_ENABLE_1);
		m_check_Enabled[RATEITEM_ZARJPY][LIMIT_INDEX_1] = GetDlgItem(IDC_LIMIT_CHECK_ZARJPY_ENABLE_2);

		m_label_Status[RATEITEM_CANJPY][LIMIT_INDEX_0]  = GetDlgItem(IDC_LIMIT_STATIC_CADJPY_STATUS_1);
		m_label_Status[RATEITEM_CANJPY][LIMIT_INDEX_1]  = GetDlgItem(IDC_LIMIT_STATIC_CADJPY_STATUS_2);
		m_label_Status[RATEITEM_CHFJPY][LIMIT_INDEX_0]  = GetDlgItem(IDC_LIMIT_STATIC_CHFJPY_STATUS_1);
		m_label_Status[RATEITEM_CHFJPY][LIMIT_INDEX_1]  = GetDlgItem(IDC_LIMIT_STATIC_CHFJPY_STATUS_2);
		m_label_Status[RATEITEM_HKDJPY][LIMIT_INDEX_0]  = GetDlgItem(IDC_LIMIT_STATIC_HKDJPY_STATUS_1);
		m_label_Status[RATEITEM_HKDJPY][LIMIT_INDEX_1]  = GetDlgItem(IDC_LIMIT_STATIC_HKDJPY_STATUS_2);
		m_label_Status[RATEITEM_GBPUSD][LIMIT_INDEX_0]  = GetDlgItem(IDC_LIMIT_STATIC_GBPUSD_STATUS_1);
		m_label_Status[RATEITEM_GBPUSD][LIMIT_INDEX_1]  = GetDlgItem(IDC_LIMIT_STATIC_GBPUSD_STATUS_2);
		m_label_Status[RATEITEM_USDCHF][LIMIT_INDEX_0]  = GetDlgItem(IDC_LIMIT_STATIC_USDCHF_STATUS_1);
		m_label_Status[RATEITEM_USDCHF][LIMIT_INDEX_1]  = GetDlgItem(IDC_LIMIT_STATIC_USDCHF_STATUS_2);
		m_label_Status[RATEITEM_ZARJPY][LIMIT_INDEX_0]  = GetDlgItem(IDC_LIMIT_STATIC_ZARJPY_STATUS_1);
		m_label_Status[RATEITEM_ZARJPY][LIMIT_INDEX_1]  = GetDlgItem(IDC_LIMIT_STATIC_ZARJPY_STATUS_2);

		for ( int intUNITIndex = RATEITEM_CANJPY ; intUNITIndex < RATEITEM_ZARJPY + 1 ; intUNITIndex++ ) {
			for ( int intIndex = 0 ; intIndex < LIMIT_INDEX_COUNT ; intIndex++ ) {
				m_check_Enabled[intUNITIndex][intIndex].SetCheck     ( g_pParameter->m_blnLimitEnabled[intUNITIndex][intIndex] );
				m_label_Status[intUNITIndex][intIndex].SetWindowText ( g_pParameter->m_strLimitStatus[intUNITIndex][intIndex] );
			}
		}

		return 0;
	}
	// OK{^
    BOOL OnApply(){
		for ( int intUNITIndex = RATEITEM_CANJPY ; intUNITIndex < RATEITEM_ZARJPY + 1  ; intUNITIndex++ ) {
			for ( int intIndex = 0 ; intIndex < LIMIT_INDEX_COUNT ; intIndex++ ) {
				m_editLimit[intUNITIndex][intIndex][LIMIT_BIDASK_BID].GetValue ( g_pParameter->m_curLimit[intUNITIndex][intIndex][LIMIT_BIDASK_BID] );
				m_editLimit[intUNITIndex][intIndex][LIMIT_BIDASK_ASK].GetValue ( g_pParameter->m_curLimit[intUNITIndex][intIndex][LIMIT_BIDASK_ASK] );
				g_pParameter->m_blnLimitEnabled[intUNITIndex][intIndex] = (m_check_Enabled[intUNITIndex][intIndex].GetCheck() == 1);
			    m_label_Status[intUNITIndex][intIndex].GetWindowText(g_pParameter->m_strLimitStatus[intUNITIndex][intIndex]);
			}
		}
		return TRUE;
	}
	//  NA{^
	void OnClickClearStatus(UINT uNotifyCode, int nID, HWND hWndCtl)
	{
		switch ( nID ) {
		case IDC_LIMIT_BUTTON_CLEAR_CADJPY_1:
			m_label_Status[RATEITEM_CANJPY][LIMIT_INDEX_0].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_CADJPY_2:
			m_label_Status[RATEITEM_CANJPY][LIMIT_INDEX_1].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_CHFJPY_1:
			m_label_Status[RATEITEM_CHFJPY][LIMIT_INDEX_0].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_CHFJPY_2:
			m_label_Status[RATEITEM_CHFJPY][LIMIT_INDEX_1].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_HKDJPY_1:
			m_label_Status[RATEITEM_HKDJPY][LIMIT_INDEX_0].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_HKDJPY_2:
			m_label_Status[RATEITEM_HKDJPY][LIMIT_INDEX_1].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_GBPUSD_1:
			m_label_Status[RATEITEM_GBPUSD][LIMIT_INDEX_0].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_GBPUSD_2:
			m_label_Status[RATEITEM_GBPUSD][LIMIT_INDEX_1].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_USDCHF_1:
			m_label_Status[RATEITEM_USDCHF][LIMIT_INDEX_0].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_USDCHF_2:
			m_label_Status[RATEITEM_USDCHF][LIMIT_INDEX_1].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_ZARJPY_1:
			m_label_Status[RATEITEM_ZARJPY][LIMIT_INDEX_0].SetWindowText("");
			break;
		case IDC_LIMIT_BUTTON_CLEAR_ZARJPY_2:
			m_label_Status[RATEITEM_ZARJPY][LIMIT_INDEX_1].SetWindowText("");
			break;
		}
	}
};
//-----------------------------------------------------------------
//  ݒ
//-----------------------------------------------------------------
class CSettingSheet : public CPropertySheetImpl<CSettingSheet>
{
private:
	PCGAITAMEMON_PARAM		m_ptblParameter;					//p^|C^
	CSetting_Internet_Page	m_pageInternet;
	CSetting_Window_Page	m_pageWindow;
	CSetting_Clock_Page		m_pageClock;
	CSetting_Limiter_1_Page	m_pageLimit_1;
	CSetting_Limiter_2_Page	m_pageLimit_2;
public:
    BEGIN_MSG_MAP(CSettingSheet)
        MSG_WM_SHOWWINDOW(OnShowWindow)
		MSG_WM_DESTROY(OnDestroy)
        CHAIN_MSG_MAP(CPropertySheetImpl<CSettingSheet>)
    END_MSG_MAP()


//	PCGAITAMEMON_PARAM    g_pParameter;							// Np^ւ̃|C^

    // RXgN^
    CSettingSheet(ATL::_U_STRINGorID title = (LPCTSTR)NULL,
        UINT uStartPage = 0, HWND hWndParent = NULL)
        : CPropertySheetImpl<CSettingSheet> (title, uStartPage, hWndParent)
    {
        m_psh.dwFlags |= PSH_NOAPPLYNOW;

        AddPage(m_pageInternet);
        AddPage(m_pageWindow);
        AddPage(m_pageClock);
		AddPage(m_pageLimit_1);
		AddPage(m_pageLimit_2);
    }

	void SetParemeterPtr ( 
		                           PCGAITAMEMON_PARAM    pParameter ,
								   CPopupMon            *pclsPopupMon 
						  )
	{
		m_ptblParameter = pParameter;
		m_pageInternet.g_pParameter = pParameter;
		m_pageWindow.g_pParameter   = pParameter;
		m_pageClock.g_pParameter    = pParameter;
		m_pageLimit_1.g_pParameter  = pParameter;
		m_pageLimit_2.g_pParameter  = pParameter;
		m_pageWindow.g_pclsPopupMon = pclsPopupMon;
	}
	// 
	void OnShowWindow( BOOL wParam, int lParam)
	{
		CenterWindow();
		SetActivePage ( m_ptblParameter->m_lngSettingWindowCurrentTab );   //Oۑp^
		return ;
	}
	//j
	void OnDestroy()
	{
		m_ptblParameter->m_lngSettingWindowCurrentTab = GetActiveIndex();
	}
    static int CALLBACK PropSheetCallback(HWND hWnd, UINT uMsg, LPARAM lParam){
        if(uMsg == PSCB_PRECREATE){
            // ReLXgwv{^폜
            ((LPDLGTEMPLATE)lParam)->style &= ~DS_CONTEXTHELP;
            return 0;
        }

        return CPropertySheetImpl<CSettingSheet>::PropSheetCallback(hWnd, uMsg, lParam);
    }
};

